misc list of things todo:

for next release?
-----------------
* exporting gated studies via DICOM and reloading doesn't work. May be an error in exporting, or an error in importing gated DICOM
* change wait cursor to be whole dialog, not just canvas
* help works in cygwin setup, but not in installed package. Seems to know the
  right place to look, just isn't doing something correctly....
* revert on dialogs doesn't work correctly... children get readded
* some sort of way to easily measure distances between fiducials [1]
 [1] suggested by Michael Braden
* freehand/isocontour roi's - draw them at high mag - will see they're shifted just slightly off voxel lines [2]
 [2] noticed by Mark Huisman
* dcmtk shouldn't be required for mac os x install - figure out how to embed
  dicom.dic
* view_thickness isn't read in from .xif file - gets overridden at some point
* Gate picker -> multiple selection still screwed up


to test on win32
----------------
* export pixel size text boxes get ignored - likely using wrong "update" event
  (noticed by Priti Madhav and Ian Miller)

remaining things to do now that we're using gtk 2.10
----------------------------------------------------
1. combine open and import menu items onto same file dialog.
	There's no reason this can't currently be done on the AMIDE side.  There's a function
	for detecting if a file/directory is a XIF, and if it's not, we just hand it off to
	libmdc.  Need to wait on a new version of the file dialog (gtk 2.4) that allows
	specifying our own filters for figuring out what goes in the lists... XIF 
	directories need to go on the "files" side.  And also would need a drop down for 
	switching from "guess" to "import particular", like in gimp.
	- similarly, the export data set functions should work similarly, with an additional
	option on whether or not we want the data resliced.
	* amitk_xif_sel uses deprecated GtkOptionMenu (gtkfilesel uses this also)
	  remove amitk_xif_sel when conversion to the new file selection is done
        * should probably offer an option for displaying a default "/volumes" directory
2 as of 2.12, gtk_file_selection deprecated. have undef GTK_DISABLE_DEPRECATED in 
  tb_export_data_set.c, tb_fly_through.c, tb_profile.c, tb_roi_analysis.c, ui_common.c, ui_render.c,
  ui_render_movie.c, ui_series.c, ui_study_cb.c


windows todo
------------
* zdial on rendering doesn't work

factor analysis things:
-----------------------       
* factor analysis -> should be able to do from ROI's too.
	should be simple.  1 iteration to find the # of voxels,
	second iteration to fill in 
	probable use weight >=0.5 as cutoff
* need to add orthogonality component back into PLS
* principle component analysis should probably be demeaned
* need to extend 2 comp to 3 comp (or n-comp)
* should be able to combine main function for fads and comp models


big things:
-----------
* figuring out orientation from files loaded from xmedcon isn't strictly correct, and screws up with NIFTI format
  look at notes in libmdc_interface.c. Also would likely need fixes in libmdc itself (see
  0.10.3_nifti_unsubmitted changes)
* add drag-n-drop capabilities between study windows
	don't use treeview reorderable stuff, too limited,
* toolbox dialog for generating polar maps (requested by Jeff Arkles and others)
* should be able to specify units the image/display info is in, and request different output units.
	-allow changing of displayed units (mm, cm, m, s, min, uCi, Beq, etc.)
	-study would have an output units variable
	-each data set, can specify it's original units, and (if needed), a scaling factor to output unit
	-ui_preferences would change default units
	-need gobject based approach, so widgets can listen for change
	-> start with mm/cm/m
* add a data sets list item,
	-would allow reading in multi-bed data sets
	-raw_data type could have amitk_space made its parent, so it has its own space...
* calculating PV correction.  
	Correction factors could be calculated for each volume's 
	resolution and then cached.
* multi-step undo/redo, look into how other GTK apps do it
	-once this is done, drop the enact/cancel bit of shifting data sets and study's
	  as we can now just undo such a change
* add image calculator
	-you pick data set, then subtract/divide/etc. another data set from
	 picked data set, with slices grabbed via amitk_data_set_get_slice to
	 be in the coordinate set of the picked data set.
* create an AmitkAnalysis type, holding voxel statistics
	-when created, passed a study
	-use callbacks, so that stats are marked as current or obsolete,
	 stats also marked as obsolete if a AmitkAnalysis calculation type
         changed from "fast" to "accurate" or back
        -stats are only (re)calculated as needed (i.e. when stat values/raw values are requested)
        -has a callback "amitk_analysis_changed", so that the roi_analysis_widget
         knows to update it's table.
        -function to request stats as an array of structs
        -function to request raw values as array of structs
* ability to import and export AIR .air files
  -probably from rotate axis page
  -need object list widget: should update automatically when something is removed somewhere else

                       
small things:
-------------
* pop-up widget allowing value underneath cursor to be shown for all data sets (not just active). (requested by Axel Moeller)
* hot key to cycle through time frames (requested by Michael Braden)
* allow direct entry of transformation matrix in amitk_space_edit
* data set icons in amitk_tree could be generated from the actual respective data sets
* .xif files should try to compress data.
* amitk_preferences.c : default color table, panel layout, layout should be saved in gconf as they 
  associated strings for these values, not as the enumerated numbers
* change tb_filter, tb_crop, tb_fads, so that an amitk_tree is used for the
	initial popup letting you change which data set will be used
* export ROI's to external file? and allow import?
* continue implementing progress bars for various functions:
	-roi analysis
	-loading in data sets
* could probably subclass isocontour's from AmitkRoi -> AimtkIsocontourRoi
	would allow simplification of amitk_canvas event cruft
	also probably get rid of amitk_roi_variable_types.c... not worth the performance improvement
* add sqrt and log abilities into color table lookup?
* should have option to use rigid body registration with scaling
* try to work in the max/min/distribution calculations into the loading loop
* fix zooming of off angle roi's on the canvas
* should all voxel's that an roi edge passes through be displayed?
        -would mean creating roi canvas object as pixmap, similar to isocontour
* roi analysis dialog should probably be updated for any change of the roi's
* rendering movie generation should allow rotating around one axis, then another, then another
	maybe an ability to script the movie?
* add key combination that sets current pixel value to max/min threshold
                                                                                


pre 1.0 things:
--------------
* try to change dialog box buttons to verbs
* start commenting the widgets, run gtk-doc to generate documentation
* check README's, INSTALL guides, etc.
* add tooltips to everything....
* add more help buttons to the dialogs 


probably post 1.0 things:
----------------
* add report generation.  This would add colormaps, location, thickness
	study name, volume name, scan date, etc. to the export function.
	Would handle multiple images.
* rendering alterations -> 
	3D red/green imaging
	allow rotation of light source and view in addition to object
	allow changing of material properties
	transformation to rendering structure is inefficient when doing multiple volumes,
		each volume should be transfered using it's minimal voxel size, not the
		group's maximum minimal voxel size.  the rendered images should then be scaled
		and overlapped.  
	MIP rendering would be nice....
	More likely, will switch to using VTK at some point
* aligning of data using automated registration?


libgnomecanvas/pixbuf issues
---------------------

these problems will probably never be rectified, as libgnomecanvas is
now deprecated. More likely course of action will be likely to rewrite
the parts that use libgnomecanvas to use a new canvas system, but a
new canvas system has not yet been agreed on for gtk (as of 2.14 at
least).

* antialiased canvases have been disabled again, due to instabilities with ROI resizing
	starts spewing "*** attempt to put segment in horiz list twice" errors
	and eventually core dumps.  Either a libart or libgnomecanvas bug.  Uncomment
	appropriate lines in configure.in to reenable

	last tested versions:
		libart_lgpl-2.3.14-1
		libgnomecanvas-2.3.6-1

	-make sure to check that lines in tb_crop are placed correctly
	-need to check that the export jpeg functions work, they have not been tested


* anti-aliased canvases doesn't support GDK line styles (as of libgnomecanvas 2.2.0)
        -ui_preferences_dialog, and amitk_object_dialog define out the appropriate code 
	when antialiasing support is cmopiled in.  Add back in once anti-aliased
	canvases support line styles.

* currently, alpha blending is done inside of image.c, a single pixbuf is generated,
	and this is handed to gnome_canvas.  It'd be nice to use separate pixbuf's but 
	each data set, and throwing them on the canvas.  The single biggest problem with this is 
	that the background buffer in gnome_canvas is RGB, not RGBA, so the buffer has an effective
	alpha of 0xFF, and you're just blending the image with whatever that background is, 
	screwing up the color levels.  may have to rewrite libgnomecanvas to use
	a 32bit buffer
	-would allow the use of cursor keys for moving data sets around each other


* using the gdk_pixbuf_scale functions
	Slicing from all data sets at zoom=1.0, and then scaling using
	the gdk_pixbuf_scale type functions doesn't work well, as the
	scale functions don't do a great job of interpolation (circa
	gdk-pixbuf-0.18.0).


things dependent on other things: 
-------------- 

* dependent on requiring gtk 2.12
 -update Default Directory bit in ui_preferences_dialog to be a
  GtkFileChooserButton


* dependent on gtk > 2.14:
  -gtk (as of 2.14) doesn't have any version of gnome_help_display. As
  such, the relevant code from libgnome has been copied into
  amide_gnome.c. When gtk has this capability, the code in
  amide_gnome.c can be deleted.

* not currently implemented in gtk (at least as of 2.12):
	handle_box's don't get minimized with the main window...
	but no way to minimize them independently...

* amide_gconf.c is used to encapsulate configuration support (based on
       gconf for unix, based on code stolen from gnumeric for
       win32). GConf is likely to be deprecated at some point in the
       future, and replaced with DConf. If DConf ever emerges, and
       looks useable, will switch to using it.


* setlocale is disabled on win32, this is because further setlocale
  commands seem to be ignored, and so reading in text hdr files
  (e.g. Concorde format ) gets screwed up for locales that use the
  comma for the radix. This is as of mingw 3.13 at least.


* ui_time_dialog specifies AmitkDataSet as G_TYPE_POINTER instead of
	AMITK_TYPE_OBJECT when setting up gtk_list_store - this is due
	to a gtk bug, adds a reference with G_TYPE_OBJECT but doesn't
	remove it
	- also in amitk_tree.c, ui_alignment_dialog.c

* at some point, GtkGammaCurve will probably be deprecated from Gtk,
	can either copy the code into amide, or come up with something
	more fitting

* when bug-buddy supports sourceforge bug reporting,
	delete the following line from amide.c so we can have bug reporting
	"signal(SIGSEGV, SIG_DFL);"

* remove no-ops in raw_data.c
	I've needed this (at least) for gcc <= 3.0.3.  Left in for the moment as
	I haven't tested gcc 3.1 for this bug, and other people may be using
	old versions of gcc.

* Current implementation is cooperative multitasking, if that.  Should turn
	program into a true, multi-threaded design.  Note that gtk for windows
	(as of 2003.04.30) does not handle multi-threaded program.... so will
	have to wait for that.

* in xml.c and amitk_point.c, have a bunch of G_PLATFORM_WIN32
	ifdef's, because g_strdup_printf
	wasn't obeying the setlocale command on windows as of glib 2.2
	This was causing errors in locales that use a comma as the
	radix sign.  Need to test if g_strdup_printf will work with later
	versions of glib.

* amitk_data_sets_export_to_file is very wasteful of memory.  It reslices the requisite
	data sets into a new data set, and then an additional copy data set is made
	inside of libmdc.  If medcon/libmdc ever supports slice-by-slice saving
	of data sets (instead of as an entire volume at once), we would only need
	to allocate one slice in amide, and one slice in libmdc, rather than
	one volume in amide, and one volume in libmdc.
	


